#!/usr/bin/python3
# -*- coding: utf-8 -*-

from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import QPushButton, QWidget, QLabel, QVBoxLayout, QHBoxLayout, QCheckBox

from mainui.systembutton import CleanButton
import gettext
gettext.textdomain("kylin-update-manager")
_ = gettext.gettext

BUTTON_LEAVE=0
BUTTON_ENTER=1
BUTTON_PRESSED=2

class select_button(QPushButton):
    def __init__(self, btn_name="", is_update=False, parent=None):
        self.is_update=is_update
        super(select_button, self).__init__(parent)
        self.resize(100, 40)
        self.setFocusPolicy(Qt.NoFocus)
        self.setText(btn_name)
        self.status = BUTTON_LEAVE
        if self.is_update==False:
            text = self.text()
            if text == _("Cancel") or text == _("quit"):
                self.setStyleSheet("QPushButton{border-radius:4px;background-color:#d9d9d9;color:#444444;font-size:16px;}")
            else:
                self.setStyleSheet("QPushButton{border-radius:4px;background-color:#3d6be5;color:#ffffff;font-size:16px;}")
        else:
            self.setDisabled(True)
            self.setStyleSheet("QPushButton{border-radius:4px;background-color:#e9e9e9;color:#c1c1c1;font-size:16px;}")

    #
    # 函数：鼠标进入事件
    #
    def enterEvent(self, event):
        self.status = BUTTON_ENTER
        if self.is_update==False:
            self.setStyleSheet("QPushButton{border-radius:4px;background-color:#6b8eeb;color:#ffffff;font-size:16px;}")
        else:
            self.setDisabled(True)
            self.setStyleSheet("QPushButton{border-radius:4px;background-color:#e9e9e9;color:#c1c1c1;font-size:16px;}")
        self.update()

    #
    # 函数：鼠标按下事件
    #
    def mousePressEvent(self, event):
        if (event.button() == Qt.LeftButton):
            self.mouse_press = True
            self.status = BUTTON_PRESSED
            if self.is_update==False:
                self.setStyleSheet("QPushButton{border-radius:4px;background-color:#4e5fc4;color:#ffffff;font-size:16px;}")
            else:
                self.setDisabled(True)
                self.setStyleSheet("QPushButton{border-radius:4px;background-color:#e9e9e9;color:#c1c1c1;font-size:16px;}")
            self.update()

    #
    # 函数：鼠标释放事件
    #
    def mouseReleaseEvent(self, event):
        if (self.mouse_press and self.rect().contains(event.pos())):
            self.mouse_press = False
            self.status = BUTTON_ENTER
            self.update()
            self.clicked.emit(True)

    #
    # 函数：鼠标离开事件
    #
    def leaveEvent(self, event):
        self.status = BUTTON_LEAVE
        if self.is_update==False:
            text=self.text()
            if text==_("Cancel") or text==_("quit"):
                self.setStyleSheet("QPushButton{border-radius:4px;background-color:#d9d9d9;color:#444444;font-size:16px;}")
            else:
                self.setStyleSheet("QPushButton{border-radius:4px;background-color:#3d6be5;color:#ffffff;font-size:16px;}")

        else:
            self.setDisabled(True)
            self.setStyleSheet("QPushButton{border-radius:4px;background-color:#e9e9e9;color:#c1c1c1;font-size:16px;}")
        self.update()

class allselectwidget(QWidget):
    tristate_status = 2
    click_main_cb = pyqtSignal(int)

    def __init__(self,width,hight,text1,text2="",text3="",need_button=False,parent=None):
        self.need_button = need_button
        super(allselectwidget,self).__init__(parent)
        self.setFixedSize(width,hight)
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(231, 231, 231))
        self.setPalette(palette)

        # self.cb = CleanButton(self.is_update,self)
        self.cb = QCheckBox(self)

        #self.cb.toggled.connect(self.slot_toggle_cb)
        #self.cb.setStyleSheet("{border-radius:6px;border:1px solid #cfcfcf;}")
        self.label_all_select = QLabel()

        #self.label_all_select.setFrameShape(QFrame.NoFrame)
        self.label_all_select.setText(text1)
        #self.label_all_select.resize(100,16)
        self.label_all_select.setStyleSheet("QLabel{color:#444444;font-size:14px;}")
        self.label_num = QLabel()
        self.label_num.setText(text2)
        self.label_num.setStyleSheet("QLabel{color:#f4812c;font-size:14px;font-weight:bold;}")
        self.label_2 = QLabel()
        self.label_2.setText(text3)
        self.label_2.setStyleSheet("QLabel{color:#444444;font-size:14px;}")

        if self.need_button:
            # self.button_update = select_button(_("Update"), self.is_update, self)
            self.button_update = QPushButton(self)
            self.button_update.setText(_("Update"))
            self.button_update.setFocusPolicy(Qt.NoFocus)
            self.button_update.setFixedSize(100, 40)
            self.button_update.setGeometry(430, 15, 100, 40)
            self.button_update.show()

            # self.button_cancel = select_button(_("Cancel"), self.is_update, self)
            self.button_cancel = QPushButton(self)
            self.button_cancel.setText(_("Cancel"))
            self.button_cancel.setFocusPolicy(Qt.NoFocus)
            self.button_cancel.setFixedSize(100, 40)
            self.button_cancel.setGeometry(318, 15, 100, 40)
            self.button_cancel.show()

            layout_h_cb = QHBoxLayout()
            layout_h_cb.addSpacing(5)
            layout_h_cb.addWidget(self.cb)
            layout_h_cb.setSpacing(15)
            layout_h_cb.addWidget(self.label_all_select)
            layout_h_cb.addWidget(self.label_num)
            layout_h_cb.addWidget(self.label_2)
            layout_h_cb.addStretch()
            layout_h_cb.addSpacing(282)
        else:
            layout_h_cb = QHBoxLayout()
            layout_h_cb.addSpacing(5)
            layout_h_cb.addWidget(self.cb)
            layout_h_cb.setSpacing(15)
            layout_h_cb.addWidget(self.label_all_select)
            layout_h_cb.addWidget(self.label_num)
            layout_h_cb.addWidget(self.label_2)
            layout_h_cb.addStretch()

        layout_v_cb = QVBoxLayout()
        layout_v_cb.addStretch()
        layout_v_cb.addLayout(layout_h_cb)
        layout_v_cb.addStretch()
        self.setLayout(layout_v_cb)
        self.init_ui()

    def init_ui(self):
        self.cb.setFocusPolicy(Qt.NoFocus)
        self.cb.setCheckState(Qt.Checked)
        self.cb.setStyleSheet(
            "QCheckBox{border-radius:4px;spacing: 0px;color:#666666;font-size:14px;background-color:#FFFFFF;}"
            "QCheckBox:hover{background-color:#DAE3FA;}"
            "QCheckBox::indicator{width: 16px;height: 16px;border-radius:4px;}"
            "QCheckBox::indicator:unchecked{background-color:#FFFFFF;border:1px solid #bfbfbf;}"
            "QCheckBox::indicator:unchecked:hover{background-color:#DAE3FA;border:1px solid #6B8EEB;}"
            "QCheckBox::indicator:unchecked:pressed{background-color:#BCCCF6;border:1px solid #415FC4;}"
            "QCheckBox::indicator{width: 16px;height: 16px;border-radius:4px;}"
            "QCheckBox::indicator:checked{background-color:#3D6BE5;border:1px solid #415FC4;image: url(./res/check);}"
            "QCheckBox::indicator:checked:hover{background-color:#6B8EEB;border:1px solid #415FC4;image: url(./res/check);}"
            "QCheckBox::indicator:checked:pressed{background-color:#415FC4;border:1px solid #415FC4;image: url(./res/check);}")

        if self.need_button:
            self.button_cancel.setStyleSheet("QPushButton{border-radius:4px;background-color:#d9d9d9;color:#444444;font-size:16px;}"
                                            "QPushButton:hover{border-radius:4px;background-color:#6b8eeb;color:#ffffff;font-size:16px;}"
                                            "QPushButton:pressed{border-radius:4px;background-color:#4e5fc4;color:#ffffff;font-size:16px;}")
            self.button_update.setStyleSheet("QPushButton{border-radius:4px;background-color:#3d6be5;color:#ffffff;font-size:16px;}"
                                            "QPushButton:hover{border-radius:4px;background-color:#6b8eeb;color:#ffffff;font-size:16px;}"
                                            "QPushButton:pressed{border-radius:4px;background-color:#4e5fc4;color:#ffffff;font-size:16px;}")

    #
    # 函数：获取cb状态
    #
    def get_checkbox_status(self):
        return self.checkBox.isChecked()
