#-*- coding:utf-8 -*-
import configparser

from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import QListWidgetItem, QDialog

from mainui.log_widget import *
from utils.enums import (BUTTON_ENTER, BUTTON_LEAVE, BUTTON_PRESSED, BUTTON_DISABLE)
from mainui.updatelistitemwidget import *
from utils.db_install_information import *
from utils.enums import AppMsg, CONF_MODEL_PATH
from mainui.appdetails import *
from mainui.package_massage_widget import *
import sys
import os
from mainui.confwidget import ConfigWidget
from mainui.aboutwidget import *
import gettext
gettext.textdomain("kylin-update-manager")

_ = gettext.gettext

class Menubar(QDialog):
    clicked_btn_statue = pyqtSignal(bool)
    leave_btn = pyqtSignal()
    enter_btn=pyqtSignal()
    m_parent=None
    clicked_btn=False
    firsttime_click_item = True
    firsttime_clicked_statue_menu = True
    firsttime_clicked_time_menu = True
    order_statue = 0
    update_statue = 3
    res_online = None
    res_local = None

    # conf_path = os.path.join(xdg.xdg_cache_home, "kylin-update-manager/kylin-update-manager.conf")
    def __init__(self,width,height,x,y, parent=None):
        self._width=width
        self._height=height
        self._x=x
        self._y=y
        self.status = BUTTON_ENTER
        self.time=QTimer()
        self.is_search = False

        super(Menubar, self).__init__(parent)
        self.setAttribute(Qt.WA_TranslucentBackground)
        self.setWindowFlags(Qt.FramelessWindowHint | Qt.Tool)
        self.m_parent=parent
        #self.iface = iface
        #self.setAttribute(Qt.WA_TranslucentBackground)
        self.widget=QWidget(self)
        self.widget.setStyleSheet(".QWidget{border:1px solid #cfcfcf;}")
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(self.backgroundRole(), QColor(255, 255, 255))
        self.setPalette(palette)
        self.initui()

        self.config_widget = ConfigWidget(self.m_parent)
        self.config_widget.hide()
        self.about_widget = AboutWidget(self.m_parent)
        self.about_widget.hide()
        self.log_widget = LogWidget(self.m_parent)
        self.log_widget.hide()
        self.package_massage_widget = Package_Massage_Widget(self.m_parent)
        self.package_massage_widget.hide()
        self.init_connect()
        # self.init_stylesheet()
        self.show()

    def paintEvent(self, event):
        # 阴影
        path = QPainterPath()
        path.setFillRule(Qt.WindingFill)
        pat = QPainter(self)
        pat.setRenderHint(pat.Antialiasing)
        # print(opt.palette.base().color())
        pat.fillPath(path, QBrush(Qt.white))

        color = QColor(0, 0, 0, 50)

        for i in range(10):

            i_path = QPainterPath()
            i_path.setFillRule(Qt.WindingFill)
            ref = QRectF(10 - i, 10 - i, self.width() - (10 - i) * 2, self.height() - (10 - i) * 2)
            if i == 0:
                pass
            else:
                i_path.addRoundedRect(ref, 0, 0)
                color.setAlpha(int(150 - i ** 0.5 * 50))
                pat.setPen(color)
                pat.drawPath(i_path)
        # 主题

        ref = QRectF(10, 10, self.width() - 20, self.height() - 20)
        p = QPainter(self)
        p.setRenderHint(QPainter.Antialiasing)
        p.setBrush(Qt.white)
        p.setPen(Qt.transparent)
        p.setPen(Qt.NoPen)
        # p.drawRect(opt.rect)
        p.drawRoundedRect(ref, 0, 0)

    def initui(self):
        self.setGeometry(self._x+340, self._y+24, 160, 164)
        self.widget.setGeometry(10, 10, self.width()-20, self.height()-20)
        # self.widget.setStyleSheet("QWidget{background-color:red}")
        self.setWindowFlags(Qt.FramelessWindowHint|Qt.WindowStaysOnTopHint|Qt.ToolTip)
        #self.setAttribute(Qt.WA_TranslucentBackground,True)
        self.set_btn = listwidget(_("Setting"),self)
        #self.set_btn.checkBox.hide()
        self.set_btn.move(14,14)
        self.about_btn = listwidget(_("About"),self)
        #self.about_btn.checkBox.hide()
        self.about_btn.move(14,50)
        self.log_btn = listwidget(_("Log"),self)
        self.log_btn.move(14,82)
        self.down_package = listwidget(_("Pkg info"), self)
        self.down_package.move(14, 118)
        #self.light_color_btn = listwidget("浅色模式",self)
        #self.light_color_btn.checkBox.setCheckState(Qt.Checked)
        self.line_label1 = QLabel(self)
        self.line_label1.setFixedSize(140,1)
        self.line_label1.move(10,45)
        self.line_label1.setStyleSheet("QLabel{background-color:#eff0ef;border:1px solid #cfcfcf;}")
        self.line_label2 = QLabel(self)
        self.line_label2.setFixedSize(140,1)
        self.line_label2.move(10,81)
        self.line_label2.setStyleSheet("QLabel{background-color:#eff0ef;border:1px solid #cfcfcf;}")
        self.line_label3 = QLabel(self)
        self.line_label3.setFixedSize(140, 1)
        self.line_label3.move(10, 117)
        self.line_label3.setStyleSheet("QLabel{background-color:#eff0ef;border:1px solid #cfcfcf;}")

    def additem(self,title=" "):
        item = QListWidgetItem()
        itemwidget = listwidget(title,self)
        self.itemlist.addItem(item)
        self.itemlist.setItemWidget(item,itemwidget)

    #
    #函数:初始化信号槽
    #
    def init_connect(self):
        #self.leave_btn.connect(self.mouse_leave_event)
        #self.enter_btn.connect(self.slot_enter_btn)
        #self.itemlist.itemClicked.connect(self.slot_click_item)
        self.about_btn.clicked_btn.connect(self.slot_clicked_btn)
        self.set_btn.clicked_btn.connect(self.slot_clicked_btn)
        self.log_btn.clicked_btn.connect(self.slot_clicked_btn)
        self.down_package.clicked_btn.connect(self.slot_clicked_btn)
        self.about_btn.is_checked.connect(self.slot_clicked_btn)
        self.set_btn.is_checked.connect(self.slot_clicked_btn)
        #self.light_color_btn.clicked_btn.connect(self.slot_clicked_btn)
        #self.dark_color_btn.clicked_btn.connect(self.slot_clicked_btn)
        self.log_widget.search_line.textChanged.connect(self.m_parent.slot_textChanged)
        self.log_widget.search_line.editingFinished.connect(self.slot_editingFinished)
        self.log_widget.search_image.clicked.connect(self.slot_clicked_clear_btn)
        self.log_widget.linewidget.label_text.clicked.connect(self.slot_show_time_menu)
        self.log_widget.linewidget.label_image.clicked.connect(self.slot_show_time_menu)
        self.log_widget.app_infmation_list.itemClicked.connect(self.slot_click_online_item)
        self.log_widget.local_infmation_list.itemClicked.connect(self.slot_click_local_item)

    #
    #点击菜单中选项
    #
    def slot_clicked_btn(self,string):
        if (string == "设置") or(string == "Setting"):
            self.slot_click_config_button()
        elif (string == "关于") or (string == "About"):
            self.slot_click_about_button()
        elif (string == "日志") or (string == "Log"):
            self.slot_click_log_button()
        elif (string == "包信息" or string == "Pkg info" ):
            self.slot_click_massage_button()

    #
    #函数：点击包下载
    #
    def slot_click_massage_button(self):
        self.hide()
        self.package_massage_widget.show()
        self.package_massage_widget.raise_()
        self.package_massage_widget.move(self._x + (self._width - self.package_massage_widget.width()) / 2,
                                self._y + (self._height - self.package_massage_widget.height()) / 2)

    #
    #函数:点击设置按钮
    #
    def slot_click_config_button(self):
        self.clicked_btn=True
        self.clicked_btn_statue.emit(self.clicked_btn)
        #self.config_widget=ConfigWidget(self)
        self.config_widget.bootauto_check_file.connect(self.on_bootautocheck_changed)
        self.config_widget.daily_check_file.connect(self.on_dailycheck_changed)
        self.config_widget.move(self._x+(self._width-self.config_widget.width())/2,self._y+(self._height-self.config_widget.height())/2)
        self.config_widget.raise_()
        self.config_widget.show()
        # self.config_widget.exec_()
        self.config_widget.bootautocheckbt.checkedChanged.connect(self.on_bootautocheck_changed)
        self.config_widget.dailycheckbt.checkedChanged.connect(self.on_dailycheck_changed)
        self.hide()

    #
    #函数:点击关于按钮
    #
    def slot_click_about_button(self):
        self.clicked_btn=True
        self.clicked_btn_statue.emit(self.clicked_btn)
        #self.about_widget=AboutWidget(self)
        self.msg = "麒麟更新管理器是一款用于更新的软件，可以提醒用户哪些软件可以更新,同时开发者可以向用户推送软件。软件目前已实现了开机自动启动、定时启动和手动启动三种启动模式。具备提示下载、更新和安装，以及系统重要和关键软件、安全补丁等自动下载等功能。"
        self.about_widget.text_box.setText(self.msg)
        self.about_widget.text_company.setText(_("Ubuntu Kylin Official website") + ": www.kylinos.cn \n" + _(
            "the development team") + ":kylin Developemt Team <support@kylinos.cn> ")
        self.about_widget.move(self._x+(self._width-self.about_widget.width())/2,self._y+(self._height-self.about_widget.height())/2)
        self.about_widget.raise_()
        self.about_widget.update()
        self.about_widget.show()
        self.hide()

    #
    # 函数：点击日志按钮
    #
    def slot_click_log_button(self):
        self.clicked_btn = True
        self.clicked_btn_statue.emit(self.clicked_btn)
        # self.log_widget = LogWidget(self)
        self.log_widget.move(self._x + (self._width - self.log_widget.width()) / 2,
                             self._y + (self._height - self.log_widget.height()) / 2)
        self.log_widget.app_infmation_list.clear()
        self.log_widget.search_line.clear()
        self.log_widget.app_infmation_list.verticalScrollBar().valueChanged.connect(self.get_new_online_listitem)
        self.select_app()
        self.log_widget.raise_()
        self.log_widget.show()
        self.hide()

    #
    #函数：界面显示时的查找数据库
    #
    def select_app(self):
        installed_db = install_information()
        installed_db.select()
        self.res_online = installed_db.cursor.fetchall()
        # res = self.res_online
        if(len(self.res_online)<20):
            for item in self.res_online:
                self.insert_to_listwidget(item)
        else:
            i = 0
            for item in self.res_online:
                if(i>=20):
                    # print("break:", self.log_widget.app_infmation_list.verticalScrollBar().maximum())
                    break
                i = i+1
                self.insert_to_listwidget(item)
        installed_db.connect.commit()
        installed_db.cursor.close()
        installed_db.connect.close()

    #
    #函数：当滚动条滑至底端时
    #
    def get_new_online_listitem(self,n):
        # print("n:",n)
        count = self.log_widget.app_infmation_list.count()
        # print("len:",self.log_widget.app_infmation_list.verticalScrollBar().maximum())
        if(self.log_widget.app_infmation_list.verticalScrollBar().maximum() == n):
            """installed_db = install_information()
            installed_db.select()
            res = installed_db.cursor.fetchall()"""
            if self.res_online == None:
                pass
            i = 0
            # print("count:",count, "len:",len(self.res_online))
            if(len(self.res_online)-count >= 20):
                for item in self.res_online:
                    if (i <= count):
                        i = i + 1
                        continue
                    if(i>count+20):
                        break
                    i = i + 1
                    self.insert_to_listwidget(item)
            else:
                for item in self.res_online:
                    if (i <= count):
                        i = i + 1
                        continue
                    i = i + 1
                    self.insert_to_listwidget(item)

    #
    # 函数：当滚动条滑至底端时
    #
    # def get_new_local_listitem(self, n):
    #     count = self.log_widget.local_infmation_list.count()
    #     if (self.log_widget.local_infmation_list.verticalScrollBar().maximum() == n):
    #         """installed_db = install_information()
    #         installed_db.select()
    #         res = installed_db.cursor.fetchall()"""
    #         if self.res_local == None:
    #             pass
    #         i = 0
    #         if (len(self.res_local) - count >= 50):
    #             for item in self.res_local:
    #                 if (i <= count):
    #                     i = i + 1
    #                     continue
    #                 if (i > count + 50):
    #                     break
    #                 i = i + 1
    #                 self.insert_to_listwidget(item)
    #         if (len(self.res_local) - count < 50):
    #             for item in self.res_local:
    #                 if (i <= count):
    #                     i = i + 1
    #                     continue
    #                 if (i > len(self.res_local) - count):
    #                     break
    #                 i = i + 1
    #                 self.insert_to_listwidget(item)

    #
    #函数：在日志界面list中插入item
    #
    def insert_to_listwidget(self,item):
        appname = item[0]
        version = item[1]
        time = item[2]
        description = item[3]
        icon = item[4]
        statue = item[5]
        app_msg = AppMsg()
        app_msg.ZH_CN_NAME = ""
        app_msg.NAME = appname
        app_msg.SIZE = ""
        app_msg.BYTESIZE = ""
        app_msg.INSTALLEDVERSION = version
        app_msg.CANDIDATEVERSION = ""
        app_msg.DESCRIPTION = description
        if statue == "Fail":
            app_msg.STATUE = _("update failed")
        else:
            app_msg.STATUE = _("update seccussed")
        if os.path.exists(icon):
            app_msg.ICON = icon
        else:
            if (appname == "kylin-update-desktop"):
                app_msg.ICON = "./res/SP_icon.png"
            elif (appname == "kylin-update-manager"):
                app_msg.ICON = "./res/icon.png"
            else:
                app_msg.ICON = "./res/soft_logo.png"
        item = QListWidgetItem()
        list_item = LogListItemWidget(app_msg,self.m_parent, True)
        list_item.setFixedHeight(85)
        list_item.setStatusTip(str(app_msg.BYTESIZE))
        list_item.splitlabel.move(0, 84)
        time1 = time.split()
        list_item.installed_time_label.setText(time1[0])
        list_item.installed_time_label.move(345, 40)
        list_item.installed_time_label.show()
        if (app_msg.STATUE == _("update failed")):
            list_item.install_statue.setStyleSheet(
                "QLabel{font-size:12px;color:#d88888;border:0px solid #cfcfcf;}")
        list_item.install_statue.setText(app_msg.STATUE)
        list_item.install_statue.move(270, 40)
        list_item.install_statue.show()
        list_item.logolabel.hide()
        list_item.applabel.move(15, 14)
        list_item.applabel.setFixedWidth(240)
        list_item.appdescrible.move(15, 60)
        list_item.appdescrible.setFixedWidth(240)
        list_item.installed_versionlabel.move(15, 40)
        list_item.installed_versionlabel.setFixedWidth(240)
        list_item.installed_versionlabel.show()
        item.setWhatsThis(app_msg.DESCRIPTION)
        self.log_widget.app_infmation_list.addItem(item)
        self.log_widget.app_infmation_list.setItemWidget(item, list_item)



    #
    #函数:处理点击搜索框的x和放大镜
    #
    def slot_clicked_clear_btn(self):
        if(self.is_search == False):
            self.is_search = True
            self.log_widget.search_line.clear()
            self.log_widget.search_widget.setStyleSheet(".QWidget{background-color:#ffffff;border:1px solid #d9d9d9;}")
            self.log_widget.search_image.setStyleSheet("QPushButton{background-color:#ffffff;border:0px solid #cfcfcf;font-size:12px;color:#a0a0a0;image: url(./res/search.png);}")


    #
    #函数：处理默认状态下的搜索栏
    #
    def slot_editingFinished(self):
        self.is_search = True
        self.log_widget.search_widget.setStyleSheet(".QWidget{background-color:#ffffff;border:1px solid #d9d9d9;}")
        self.log_widget.search_image.setStyleSheet("QPushButton{background-color:#ffffff;border:0px solid #cfcfcf;font-size:12px;color:#a0a0a0;image: url(./res/search.png);}")

    #
    # 函数：处理点击更新时间
    #
    def slot_show_time_menu(self):
        if(self.order_statue == 0):
            self.slot_time_select_before_show()
            self.log_widget.linewidget.label_image.setStyleSheet("QPushButton{background-color:#eff0ef;border:0px solid #cfcfcf;font-size:12px;color:#a0a0a0;image: url(./res/up.png);}")
            self.order_statue = 1
        else:
            self.slot_time_select_newest_show()
            self.log_widget.linewidget.label_image.setStyleSheet(
                "QPushButton{background-color:#eff0ef;border:0px solid #cfcfcf;font-size:12px;color:#a0a0a0;image: url(./res/down.png);}")
            self.order_statue = 0

    #
    # 函数：处理点击顺序
    #
    def slot_time_select_newest_show(self):
        # print("down")
        text = self.log_widget.search_line.text()
        self.log_widget.app_infmation_list.clear()
        self.order_statue = 0
        installed_db = install_information()
        installed_db.select_order(text,0)
        self.m_parent.show_selected_imformation(installed_db)

    #
    # 函数：处理点击顺序
    #
    def slot_time_select_before_show(self):
        # print("up")
        text = self.log_widget.search_line.text()
        # self.log_widget.local_infmation_list.clear()
        self.log_widget.app_infmation_list.clear()
        self.order_statue = 1
        installed_db = install_information()
        installed_db.select_order(text,1)
        self.m_parent.show_selected_imformation(installed_db)
        # installed_db1 = install_information()
        # installed_db1.select_order(text,1,True)
        # self.m_parent.show_selected_imformation(installed_db1,True)

    #函数：鼠标进入设置按钮
    def slot_enter_config(self):
        self.btn_setting.setStyleSheet("QPushButton{background-color:rgb(30,150,200);color:rgb(255,255,255);}")
        self.btn_about.setStyleSheet("QPushButton{background-color:rgb(15,132,180);color:rgb(255,255,255);}")

    #函数：鼠标进入关于按钮
    def slot_enter_about(self):
        self.btn_about.setStyleSheet("QPushButton{background-color:rgb(30,150,200);color:rgb(255,255,255);}")
        self.btn_setting.setStyleSheet("QPushButton{background-color:rgb(15,132,180);color:rgb(255,255,255);}")

    #函数：处理鼠标进入信号
    def slot_enter_btn(self):
        x=QCursor.pos().x()
        y=QCursor.pos().y()
        x=x-self.x()-self._x+self.btn_setting.x()
        y=y-self.y()-self._y+self.btn_setting.y()
        if ((self.btn_about.x()<=x)and(x<=(self.btn_about.x()+self.btn_about.width())))and((self.btn_about.y()<=y)and(y<=(self.btn_about.height()+self.btn_about.y()))):
            self.slot_enter_about()
        elif ((self.btn_setting.x()<=x)and(x<=(self.btn_setting.x()+self.btn_setting.width())))and((self.btn_setting.y()<=y)and(y<=self.btn_setting.y()+self.btn_setting.height())):
            self.slot_enter_config()
        else:
            self.btn_setting.setStyleSheet("QPushButton{background-color:rgb(15,132,180);color:rgb(255,255,255);}")
            self.btn_about.setStyleSheet("QPushButton{background-color:rgb(15,132,180);color:rgb(255,255,255);}")

    #
    # 函数：点击在线更新item
    #
    def slot_click_online_item(self, item):
        get_widget = self.log_widget.app_infmation_list.itemWidget(item)
        self.show_app_detail_widget(get_widget)

    #
    # 函数：点击本地更新item
    #
    def slot_click_local_item(self, item):
        get_widget = self.log_widget.local_infmation_list.itemWidget(item)
        self.m_parent.show_app_detail_widget(get_widget)

    def show_app_detail_widget(self, get_widget):
        if self.firsttime_click_item == True:
            self.firsttime_click_item = False
            self.app_details = appdetails(get_widget,self.m_parent)
            appversion = get_widget.installed_versionlabel.text()
            self.app_details.top_widget.appversionlabel.setText(appversion)
            self.app_details.descriplabel.clear()
            self.app_details.descriplabel.setText(get_widget.description)
            self.app_details.move(self.log_widget.x() + (self.log_widget.width() - self.app_details.width()) / 2,
                                  self.log_widget.y() + (self.log_widget.height() - self.app_details.height()) / 2)
            self.app_details.raise_()
            self.app_details.show()
        else:
            self.app_details.top_widget.applogolabel.clear()
            pixmap = QPixmap(get_widget.app_msg.ICON)
            if pixmap.isNull():
                pixmap = QPixmap("./res/soft_logo.png")
            self.app_details.top_widget.applogolabel.setPixmap(pixmap)
            self.app_details.top_widget.appversionlabel.clear()
            appversion = get_widget.installed_versionlabel.text()
            self.app_details.top_widget.app_msg = get_widget.app_msg
            self.app_details.top_widget.get_appname()
            #self.app_details.top_widget.appnamelabel.setText(get_widget.app_msg.NAME)
            self.app_details.top_widget.appversionlabel.setText(appversion)
            self.app_details.descriplabel.clear()
            self.app_details.descriplabel.setText(get_widget.description)
            self.app_details.move(self.log_widget.x() + (self.log_widget.width() - self.app_details.width()) / 2,
                                  self.log_widget.y() + (self.log_widget.height() - self.app_details.height()) / 2)
            self.app_details.raise_()
            self.app_details.show()


    #鼠标进入事件
    def enterEvent(self, event):
        self.enter_btn.emit()

    #每隔0.2秒获取鼠标的位置
    def slot_get_pos_ontime(self):
        self.time.stop()
        self.enter_btn.emit()
        self.time.start(0.2)

    #
    # 函数：鼠标离开事件
    #
    def leaveEvent(self, event):
        self.status=BUTTON_LEAVE
        self.leave_btn.emit()


    #
    # 函数：鼠标按下事件
    #
    def mousePressEvent(self ,event):
        if event.button() == Qt.LeftButton:
            self.status=BUTTON_PRESSED
        else:
            event.ignore()

    #
    # 函数：鼠标释放事件
    #
    def mouseReleaseEvent(self ,event):
        if event.button() == Qt.LeftButton:
            #判断鼠标是否点击在这个按钮
            if self.rect().contains(event.pos()):
                self.status=BUTTON_ENTER
            else:
                self.status=BUTTON_LEAVE
        else:
            event.ignore()

    #函数：鼠标移动事件
    def mouseMoveEvent(self, event):
        if(self.status==BUTTON_PRESSED):
            self.leave_btn.emit()
            self.move_pos = event.globalPos()
            self.move(self.move_pos - self.drag_pos)
            self.setWindowOpacity(1)
            event.accept()

    #处理鼠标离开事件
    def mouse_leave_event(self):
        self.hide()

    def on_bootautocheck_changed(self,checked):
        if checked :
            self.m_parent.iface.call_modify_conf(CONF_MODEL_PATH, "Starting-mode","boot-auto","YES")
            self.m_parent.iface.call_autostart_open()
        else:
            self.m_parent.iface.call_modify_conf(CONF_MODEL_PATH, "Starting-mode", "boot-auto", "NO")
            self.m_parent.iface.call_autostart_close()

    def on_dailycheck_changed(self,checked):
        if checked :
            self.m_parent.iface.call_modify_conf(CONF_MODEL_PATH, "Starting-mode", "daily", "YES")
            self.m_parent.iface.call_dailystart_open()
        else:
            self.m_parent.iface.call_modify_conf(CONF_MODEL_PATH, "Starting-mode", "daily", "NO")
            self.m_parent.iface.call_dailystart_close()


class listwidget(QWidget):
    clicked_btn = pyqtSignal(str)
    is_checked = pyqtSignal(str)
    def __init__(self,title=" ",parent=None):
        super(listwidget, self).__init__(parent)
        self.statue=BUTTON_LEAVE
        self.time = QTimer()
        self.time.start(1)
        self.time.timeout.connect(self.slot_timeout)
        self.checkbox_statue = False
        self.title=title
        self.setAutoFillBackground(True)
        self.widget = QWidget(self)
        palette = QPalette()
        palette.setColor(self.backgroundRole(), QColor(255, 255, 255))
        self.setPalette(palette)
        self.setFixedSize(132,32)
        #self.widget.setGeometry(0,0,112,32)
        self.initui()
        self.styleSheet_init()

    def initui(self):
        self.checkBox = QCheckBox(self)
        self.checkBox.resize(16,16)
        self.titlelabel = QLabel(self)
        #self.titlelabel.setFixedSize(80,16)
        self.titlelabel.setStyleSheet("QLabel{font-size:14px;color:#444444;}")
        self.titlelabel.setText(self.title)

        hlayout=QHBoxLayout()
        hlayout.addSpacing(5)
        hlayout.addWidget(self.checkBox)
        hlayout.addSpacing(8)
        hlayout.addWidget(self.titlelabel)
        hlayout.addStretch()

        vlayout = QVBoxLayout()
        vlayout.addStretch()
        vlayout.addLayout(hlayout)
        vlayout.addStretch()
        vlayout.setContentsMargins(0, 0, 0, 0)
        self.setLayout(vlayout)

    def styleSheet_init(self):
        self.checkBox.setFocusPolicy(Qt.NoFocus)
        self.checkBox.setCheckState(Qt.Unchecked)
        self.checkBox.setStyleSheet("QCheckBox{border-radius:4px;border:1px solid #ffffff ;spacing: 0px;color:#FFFFFF}" \
                                    "QCheckBox:hover{background-color:#FFFFFF;}" \
                                    "QCheckBox::indicator{width: 16px;height: 16px;border-radius:4px;}" \
                                    "QCheckBox::indicator:unchecked{background-color:#FFFFFF;}" \
                                    "QCheckBox::indicator:unchecked:hover{background-color:#FFFFFF;}" \
                                    "QCheckBox::indicator:unchecked:pressed{background-color:#FFFFFF;border:0px solid #415FC4;}" \
                                    "QCheckBox::indicator{width: 16px;height: 16px;border-radius:4px;}" \
                                    "QCheckBox::indicator:checked{background-color:#FFFFFF;border:0px solid #415FC4;image: url(./res/check2);}" \
                                    "QCheckBox::indicator:checked:hover{background-color:#FFFFFF;border:0px solid #415FC4;image: url(./res/check2);}" \
                                    "QCheckBox::indicator:checked:pressed{background-color:#FFFFFF;border:0px solid #415FC4;image: url(./res/check2);}")

        #self.checkBox.connect(self.slot_toggle_cb)

    #
    #定时检查checkbox的状态
    #
    def slot_timeout(self):
        self.time.stop()
        checkbox_statue = self.checkBox.checkState()
        if checkbox_statue == Qt.Checked:
            string = self.titlelabel.text()
            self.is_checked.emit(string)
            self.checkBox.setCheckState(Qt.Unchecked)
        self.time.start(1)

    # 鼠标进入事件

    def enterEvent(self, event):
        self.status = BUTTON_ENTER


    #
    # 函数：鼠标离开事件
    #

    def leaveEvent(self, event):
        self.status = BUTTON_LEAVE

    #
    # 函数：鼠标按下事件
    #

    def mousePressEvent(self, event):
        if event.button() == Qt.LeftButton:
            self.status = BUTTON_PRESSED
            string=self.titlelabel.text()
            self.clicked_btn.emit(string)
        else:
            event.ignore()

    '''
    #
    # 函数：点击cb槽
    #
    def slot_toggle_cb(self):
        if self.checkBox.isChecked():
            self.size_change.emit(self.statusTip(), True)
        else:
            self.size_change.emit(self.statusTip(), False)
    '''




if __name__=="__main__":
    app=QApplication(sys.argv)
    s=Menubar()
    sys.exit(app.exec_())
